SystemOrganization addCategory: #'PolySource-Core'!
SystemOrganization addCategory: #'PolySource-Tests'!

ProtoObject subclass: #PSSystemDictionaryProxy
	instanceVariableNames: 'original'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

!PSSystemDictionaryProxy methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 15:17:20.483'!
doesNotUnderstand: aMessage

	original ifNil: [^ super doesNotUnderstand: aMessage].
	
	^ aMessage sendTo: original! !

!PSSystemDictionaryProxy methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 15:14:34.987'!
install

	self isInstalled ifTrue: [^self].

	original := Smalltalk globals.
	Smalltalk instVarNamed: #globals put: self.
! !

!PSSystemDictionaryProxy methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 15:14:19.08'!
isInstalled

	^ Smalltalk globals == self! !

!PSSystemDictionaryProxy methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 15:18:46.109'!
uninstall

	self isInstalled ifFalse: [^self].
	
	Smalltalk instVarNamed: #globals put: original.
	original := nil.! !

TestCase subclass: #PSSystemDictionaryTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

!PSSystemDictionaryTestCase methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 15:22:47.123'!
test01new

	| sut |
	sut := PSSystemDictionary new.

	self assert: sut size equals: Smalltalk globals size.
	Smalltalk globals keysAndValuesDo: [:key :value |
		self assert: value == (sut at: key)].
! !

!PSSystemDictionaryTestCase methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 15:24:13.625'!
test02proxy

	| testCase sut root |
	
	sut := PSSystemDictionaryProxy new.
	root := Smalltalk globals.
	
	testCase := Smalltalk globals at: #TestCase.
	
	sut install.
	self assert: sut == Smalltalk globals.
	self assert: testCase == (Smalltalk globals at: #TestCase).
	sut uninstall.
	self assert: root == Smalltalk globals.! !

SystemDictionary subclass: #PSSystemDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

!PSSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 15:00:32.549'!
initialize: size

	super initialize: size.
	Smalltalk globals keysAndValuesDo: [ :key :value |
		self at: key put: value].! !
